ClearAll[BatchMeasurementFunction];
SetAttributes[BatchMeasurementFunction,HoldFirst];
Options[BatchMeasurementFunction]={
	MaxPower->37,
	PowerTranslationFunction:>Function[{power,f},
		Round[power-$ODMRmicrowaveAmplifierPowerCalibrationFunction[f],0.05]],
	CWFrequencies->(2870+Range[-200,0,1])*10^6,
	ExpectedRabiFrequency->Automatic,
	MinCWcontrast->0.005`,
	ExpectedFWHM->2*^6,
	MinFWHM->0.5*^6,
	MaxFWHM->10*^6,
	ImageSize->{15,15},
	ImagePixels->{150,150},
	ImageMaxCounts->60*^3,
	ImageCenter->Automatic,
	TimeBetweenAutoTracking->60,
	TrackerMaxRuns->20,
	DefaultMinCountsToStopTracking->15*^3,
	MinCountsDeterminationFunction->Function[maxCounts,maxCounts*0.8],
	MinCountsToTrack->5*^3,
	MinCountsToFail->400*^3,
	MaxCountsVariation->0.05,
	FixedAxes->None,
	LaserPowerMeterFactor:>$ODMRlaserPowerMeterFactor,
	FileNamePrefix:>FileNameJoin[{NotebookDirectory[],"data_"}],
	NVSelectorFunction->(True&),
	NVTaskList->{_->All},
	DontSaveOnSkip->False,
	AdjustScanRangeForCorrelation->False,
	CropCorrelationImage->False,
	HorizontalCorrelationOptions->{},
	HorizontalCorrelationImage->None,
	VerticalCorrelationOptions->{},
	VerticalCorrelationImage->None,
	IgnoreCorrelationFitProblems->False,
	TargetLaserPower->250*^-6,
	TargetLaserPowerAllowedDeviation->10*^-6,
	BatchParamsFile->None,
	InitialMapOffset->Automatic,
	PolarizationTestAngles->{0,\[Pi]/4,\[Pi]/2,3/4*\[Pi]},
	SnapshotIntervall->{"ODMR_cw"->\[Infinity],"ODMR_Rabi"->2*60,
		"ODMR_Ramsey"|"ODMR_Hahn"|"ODMR_pulsed"->5*60,
		"ODMR_DEER"->10*60},MaxScans->{"ODMR_cw"->200,_->1000},
	MaxScans->{"ODMR_cw"->100,_->1000},
	Frequencies->{"ODMR_cw"->(2870+Range[-200,0,1])*10^6,
		"ODMR_pulsed"->Function[#+Range[-10,10,0.1]*10^6],
		"ODMR_DEER"->Range[800,3300,2.5]*10^6,_->Automatic},
	MicrowavePower->{"ODMR_cw"->26,"ODMR_Rabi"->37,_->Automatic},
	TargetRabiFrequency->{"ODMR_pulsed"->0.25*^6,"ODMR_DEER"->{4*^6,1*^6},
		_->4*^6},
	RabiPlayerCurves->{
		"ODMR_Rabi"->"rabiNormalized2.5us201st1000.seq",
		"ODMR_Ramsey"->"RN_fr4MHz_10us401st1000.seq",
		"ODMR_Hahn"->"HN_fr4MHz_20us401st500.seq",_->Automatic},
	MeasurementOptions->{"ODMR_cw"->{PermuteFrequencies->True},_->{}},
	RabiPlayerOptions->{},
	PulsedSpectrumOptions->{PermuteFrequencies->True},
	SecondaryMicrowave->None};
BatchMeasurementFunction[map_?NVmapQ,o:OptionsPattern[]]:= 
	Module[{quit=False,abort=False,skip=False,NV,pol,
			polarization,saturation,cw,rabi,ramsey,hahn,pulsed,g2,time,
			resolution=TimeHarpGetResolution[],image,
			restoreLatestSnapshot=Function[snapshotDirectory,
				If[Length[#]>0,
					Get[FileNameJoin[{snapshotDirectory,"snapshot_"<>ToString[#]<>".m"}]]&@
					Max[StringCases[#,StartOfString~~"snapshot_"~~x:NumberString~~".m"
							~~EndOfString:>ToExpression[x]][[1]]&@
						Last@FileNameSplit[#]&/@#],None]&@
				FileNames["snapshot_*.m",{snapshotDirectory}]],
			\[Phi],laserPower,
			TaskNecessary=Function[{task,necessaryTasks},
				With[{taskAssociation={"g2"->1,"polarization"->2,"saturation"->3,
						"ODMR_cw"->4,"ODMR_Rabi"->5,"ODMR_Ramsey"->6,"ODMR_Hahn"->7,
						"ODMR_pulsed"->8,"ODMR_DEER"->9}},
					Switch[#,task,True,
					_Rule,If[#0[#[[1]]]&&!StringMatchQ[#[[2]],"skip",IgnoreCase->True],
						If[StringMatchQ[#[[2]],"restart",IgnoreCase->True],"restart",True],
						False],
					_String,task==#/.taskAssociation,
					_Integer,False,
					Span[_,_],(#[[1]]<=task&&
						Switch[#[[2]],
							_Integer?Positive,task <= #[[2]],
							All,True,
							_,Print["Warning: span specification for task not \
recognized,assuming nothing to do: "<>ToString[#]]; False])/.taskAssociation,
					_List,If[FreeQ[#,"restart"],Or@@#,"restart"]&[#0/@#],
					None,False,
					All,True,
					_,Print["Warning: task specification not recognized,assuming \
nothing to do for task "<>ToString[task]<>": "<>ToString[#]]; 
					False]&@necessaryTasks]],
			adjustMap,adjustMapNoSkip,scanImage,makeImage,updateG2,
			minCountsToStop,lastCorrelationImage,
 			handleTaskSpecificOption=Function[{optionName,pattern},
				Join[#,optionName/.Options[BatchMeasurementFunction]]&@Switch[#,
					{((Verbatim[_]|_String|_Alternatives)->pattern) ..},#,
					(Verbatim[_]|_String|_Alternatives)->pattern,{#},
					pattern,{_->#},
					_,Print["Unknown format for "<>ToString[optionName]<>
						", using defaults instead: "<>ToString[#]]; {}]&@
				OptionValue[optionName]],
			symbolQ=Function[MatchQ[#,_Symbol]],
			fitDampedOscillation,previousData,tasks},
	Module[{maxPower=OptionValue[MaxPower],
			powerTranslationFunction=
				OptionValue[PowerTranslationFunction],
			expectedRabiFrequency=
				Switch[#,Automatic,
					Function[data,
						1/2/SortBy[data,#[[2]]&][[1,1]]],_Function,#,_,
					Function[data,#]]&@OptionValue[ExpectedRabiFrequency],
			rabiFrequency,cwFrequency,fwhm,
			cwContrast,minCWcontrast=OptionValue[MinCWcontrast],
			expectedFWHM=OptionValue[ExpectedFWHM],
			minFWHM=OptionValue[MinFWHM],
			maxFWHM=OptionValue[MaxFWHM],
			ramseyPower,hahnPower,pulsedPower,deerPower,
			imageSize=OptionValue[ImageSize],
			imagePixels=OptionValue[ImagePixels],
			imageMaxCounts=OptionValue[ImageMaxCounts],
			imageCenter=
				Switch[#,_Function,#,{_?NumericQ,_?NumericQ,_?NumericQ},
					Function[#],_,Identity]&@OptionValue[ImageCenter],
			timesBetweenAutoTracking=handleTaskSpecificOption[
				TimeBetweenAutoTracking,_?NumericQ|\[Infinity]],
			defaultMinCountsToStopTracking=
				OptionValue[DefaultMinCountsToStopTracking],
			minCountsDeterminationFunction=
				OptionValue[MinCountsDeterminationFunction],
			laserPowerMeterFactor=
				If[NumberQ[#],#,
					Print["LaserPowerMeterFactor seems not to be calibrated yet,\
assuming 50"]; 50]&@OptionValue[LaserPowerMeterFactor],
			trackerMaxRuns=OptionValue[TrackerMaxRuns],
			minCountsToTrack=OptionValue[MinCountsToTrack],
			minCountsToFail=OptionValue[MinCountsToFail],
			maxCountsVariation=OptionValue[MaxCountsVariation],
			fixedAxes=OptionValue[FixedAxes],
			filePrefix=OptionValue[FileNamePrefix],
			NVselector=OptionValue[NVSelectorFunction],
			NVtasks=OptionValue[NVTaskList],
			horizontalCorrelationImage=
				OptionValue[HorizontalCorrelationImage],
			verticalCorrelationImage=
				OptionValue[VerticalCorrelationImage],
			initialMapOffset=
				Switch[#,Automatic,
					GetCurrentMapOffset[
						map],{_?NumericQ,_?NumericQ,_?NumericQ},#,_,
					Print["Invalid map offset,ignoring: "<>ToString[#]]; {0,
						0,0}]&@OptionValue[InitialMapOffset],
			\[Phi]0l=OptionValue[PolarizationTestAngles],
			dontSaveOnSkip=OptionValue[DontSaveOnSkip],
			adjustScanRangeForCorrelation=
				OptionValue[AdjustScanRangeForCorrelation] === True,
			cropCorrelationImage=OptionValue[CropCorrelationImage] === True,
			ignoreCorrelationFitProblems=
				OptionValue[IgnoreCorrelationFitProblems] === True,
			horizontalCorrelationOptions=
				Sequence@@OptionValue[HorizontalCorrelationOptions],
			verticalCorrelationOptions=
				Sequence@@OptionValue[VerticalCorrelationOptions],
			snapshotIntervalls=handleTaskSpecificOption[
				SnapshotIntervall,_?NumericQ|\[Infinity]],
			maxScans=handleTaskSpecificOption[MaxScans,_?NumericQ],
			frequencies=handleTaskSpecificOption[Frequencies,{__?NumericQ}|_Function],
			microwavePowers=handleTaskSpecificOption[MicrowavePower,
				_?NumericQ|Automatic|{(_?NumericQ|Automatic)..}],
			targetRabiFrequencies=handleTaskSpecificOption[TargetRabiFrequency,
				_?NumericQ|{__?NumericQ}],
			rabiPlayerCurves=handleTaskSpecificOption[RabiPlayerCurves,
				_String|Automatic],
			measurementOptions=handleTaskSpecificOption[MeasurementOptions,
				_List|_Rule],
			rabiPlayerOptions=OptionValue[RabiPlayerOptions],
			pulsedSpectrumOptions=OptionValue[PulsedSpectrumOptions],
			secondaryMicrowave=OptionValue[SecondaryMicrowave]},
		adjustMapNoSkip=Function[minCountsToStop,
			If[!abort,
				AutoAdjustCurrentNVPosition[map,
					TrackerMinCountsToStop->minCountsToStop,
					TrackerMinCountsToTrack->minCountsToTrack,
					TrackerMinCountsToFail->minCountsToFail,
					TrackerMaxRuns->trackerMaxRuns,
					TrackerMaxCountsVariation->maxCountsVariation,
					FixedAxes->fixedAxes,
					ReturnOldMapOnFail->False,OptimizeBelowMinCounts->{}]]];
		adjustMap=Function[minCountsToStop,
			If[!abort,If[#=!=$Failed,map=#,Print["skipping"]; skip=True]&@
				adjustMapNoSkip[minCountsToStop]]];
		scanImage=
		Function[
			Module[{c=
					Clip[#[[1]],{#[[3]]/2,#[[2]]-#[[3]]/2}]&/@
						Transpose[{#[[1 ;; 2]],GetStageRange[][[1 ;; 2]],
							imageSize}]},
				ScanConfocalImage[1,c[[1]]-imageSize[[1]]/2,
					c[[1]] + imageSize[[1]]/2,imagePixels[[1]],2,
					c[[2]]-imageSize[[2]]/2,c[[2]] + imageSize[[2]]/2,
					imagePixels[[2]],#[[3]]]]&@
			imageCenter@GetCurrentNVposition@map];
		makeImage=Function[
			If[ConfocalImageQ[verticalCorrelationImage],
			Module[{notZvalue,notZaxis,axes,range,dims,zAxisIndex},
				{notZvalue,notZaxis,axes,range,
					dims}=#[verticalCorrelationImage]&/@
						{GetConfocalImageNormalAxisValue,GetConfocalImageNormalAxis,
							GetConfocalImageAxes,GetConfocalImageRange,
							GetConfocalImageDimensions};
				zAxisIndex=Position[axes,3][[1,1]];
				If[notZvalue === Indeterminate,
				notZvalue=Mean[#[[2]]&/@map[[1]]][[notZaxis]]];
				CorrelateConfocalImages[verticalCorrelationImage,#,
							verticalCorrelationOptions,MaxSize->10,
							FreeFitSize->10]&@
						ScanConfocalImage[##,
							notZvalue + GetCurrentMapOffset[map][[notZaxis]]]& @@ 
					Flatten@
						Transpose[{axes,
							range + 
							If[adjustScanRangeForCorrelation,
								GetCurrentMapOffset[map][[axes]],0],
							dims}] // (lastCorrelationImage=#[[1]]; 
						Switch[#[[2]],{_Style,__},#[[2,1,1,1,
							1 + zAxisIndex,2]],_,Print["vertical fit problem"]; 
						Print[#]; 
						If[!ignoreCorrelationFitProblems,abort=True]; #[[2,
							1,zAxisIndex]]])& // (map=
						AdjustCurrentNVPosition[map,
						GetCurrentNVposition[map] + {0,
							0,# + initialMapOffset[[3]]-
								GetCurrentMapOffset[map][[3]]}])&
				]];
			Module[{scannedImage},
				If[ConfocalImageQ[horizontalCorrelationImage],
					Module[{zValue,zAxis,axes,range,dims},
						If[cropCorrelationImage,
							scannedImage=scanImage[];
							{zValue,zAxis,axes,range,dims}=#[scannedImage]&/@
								{GetConfocalImageNormalAxisValue,
									GetConfocalImageNormalAxis,GetConfocalImageAxes,
									GetConfocalImageRange,GetConfocalImageDimensions};
						CorrelateConfocalImages[
						CropConfocalImage[horizontalCorrelationImage,
							First/@range,-Subtract @@ #&/@range],
						scannedImage,horizontalCorrelationOptions]
						,
						{zValue,zAxis,axes,range,dims}=#[horizontalCorrelationImage]&/@
							{GetConfocalImageNormalAxisValue,GetConfocalImageNormalAxis,
								GetConfocalImageAxes,GetConfocalImageRange,
								GetConfocalImageDimensions};
						If[zValue === Indeterminate,
						zValue=Mean[#[[2]]&/@map[[1]]][[zAxis]]];
						CorrelateConfocalImages[horizontalCorrelationImage,
								scannedImage=#,horizontalCorrelationOptions]&@
							ScanConfocalImage[##,
								zValue + GetCurrentMapOffset[map][[zAxis]]]& @@ 
						Flatten@
							Transpose[{axes,
								range + 
								If[adjustScanRangeForCorrelation,
									GetCurrentMapOffset[map][[axes]],0],
								dims}]] // (lastCorrelationImage=#[[1]]; {#,
							Cases[#[[2 ;;]],{_Style,__}]} // 
							If[Length[#[[2]]]>0,#[[2,1,1,1,1,2 ;; 3,2]],
								Print["horizontal fit problem"]; Print[#[[1]]]; 
								If[!ignoreCorrelationFitProblems,abort=True]; #[[
								1,2,1,1 ;; 2]]]&)& // (map=
						AdjustCurrentNVPosition[map,
							GetCurrentNVposition[map] + 
							Append[# + initialMapOffset[[{1,2}]]-
								GetCurrentMapOffset[map][[{1,2}]],0]]; 
						adjustMap[minCountsToStop];)&
				],
				scannedImage=scanImage[]];
			PlotAndAnnotateConfocalImage[scannedImage,map(*,
				MaxCounts->imageMaxCounts*)]]
			];
		updateG2=Function[
			If[TaskNecessary["g2",tasks]=!=False,
				g2=ListLinePlot[Transpose[{resolution*(Range[Length[#]]-1),#}]&@
						If[Length[previousData]>=5&&TaskNecessary["g2",tasks]=!="restart",
							(#[[2]]&/@Cases[previousData["g2"],(Line|Point)[l_List]:>l,
								\[Infinity]][[1]])+#,#]&@
						TimeHarpGetHistogramBlock[0],PlotRange->All]]];
		fitDampedOscillation=Function[Module[{times,data,dt,a},
				Block[{A,B,C,fr,t,T0,T,\[Phi]},
					{times,data}=Transpose@Switch[#,{{_?NumericQ,_?NumericQ}..},#,
						_Graphics,Cases[#,(Line|Point)[l_List]:>l,\[Infinity]][[1]],
						{{{_?NumericQ,_?NumericQ}..}..},Function[{x,y},
							Transpose[{x[[1]],Mean[y]}]]@@Transpose[#,{2,3,1}],
						{__Graphics},Function[{x,y},Transpose[{x[[1]],Mean[y]}]]@@
							Transpose[Cases[#,(Line|Point)[l_List]:>l,\[Infinity]][[1]]&/@#,
								{2,3,1}],
						{{__Graphics},___},Function[{x,y},Transpose[{x[[1]],Mean[y]}]]@@
							Transpose[Cases[#,(Line|Point)[l_List]:>l,\[Infinity]][[1]]&/@
								#[[1]],{2,3,1}],
						_,Return[Null]];
					dt=Mean[Differences[times]];
					ExtractRelevantParametersFromFit@
					NonlinearModelFit[Transpose[{times,data}],
						B*(1-C*E^(-t/T0)
							-A/2*Cos[2*\[Pi]*fr*t+\[Phi]*\[Pi]/180]* E^(-t/T)),
						{{A,0.2},{B,Mean[data]},{C,0.02},
							{fr,expectedRabiFrequency[Transpose[{times,data}]]},
							{T,1*^-6},{T0,1*^-6},{\[Phi],0}},t]]]];
		Monitor[Module[{cwData=Null,cwFit=Null,rabiData=Null,
					rabiFit=Null,ramseyData=Null,ramseyFit=Null,hahnData=Null,
					hahnFit=Null,pulsedData,deerData,imageAfterSelection,
					imageAfterPolarization,imageAfterSaturation,imageAfterCW,
					imageAfterRabi,imageAfterRamsey,imageAfterHahn,imageAfterPulsed,
					imageAfterDEER,fileName=Function[filePrefix<>NV<>".m"],saveData,
					startTime=SessionTime[]},
				skip=False;
				minCountsToStop=defaultMinCountsToStopTracking;
				saveData=Function[If[!skip,
					(Put[#,fileName[]];#)&@
						{NV,previousData["time"]+time,map,imageAfterSelection,
							{"g2"->If[TaskNecessary["g2",tasks]=!=False&&g2=!="tbd",
								g2,previousData["g2"]],
							"polarization"->If[TaskNecessary["polarization",tasks]=!=False&&
									polarization=!="tbd",
								{polarization,180/\[Pi]*pol,imageAfterPolarization},
								previousData["polarization"]],
							"saturation"->If[TaskNecessary["saturation",tasks]=!=False&&
									saturation=!="tbd",
								{saturation,imageAfterSaturation},previousData["saturation"]],
							"ODMR_cw"->If[TaskNecessary["ODMR_cw",tasks]=!=False&&cwData=!=Null,
								{cwData,cwFit,imageAfterCW},previousData["ODMR_cw"]],
							"ODMR_Rabi"->If[TaskNecessary["ODMR_Rabi",tasks]=!=False&&
									rabiData=!=Null,
								{rabiData,rabiFit,imageAfterRabi},
								previousData["ODMR_Rabi"]],
							"ODMR_Ramsey"->If[TaskNecessary["ODMR_Ramsey",tasks]=!=False&&
									ramseyData=!=Null,
								{ramseyData,ramseyFit,imageAfterRamsey},
								previousData["ODMR_Ramsey"]],
							"ODMR_Hahn"->If[TaskNecessary["ODMR_Hahn",tasks]=!=False&&
									hahnData=!=Null,
								{hahnData,hahnFit,imageAfterHahn},previousData["ODMR_Hahn"]],
							"ODMR_pulsed"->If[TaskNecessary["ODMR_pulsed",tasks]=!=False&&
									pulsedData=!=Null,
								{pulsedData,imageAfterPulsed},previousData["ODMR_pulsed"]],
							"ODMR_DEER"->If[TaskNecessary["ODMR_DEER",tasks]=!=False&&
									deerData=!=Null,
								{deerData,imageAfterDEER},previousData["ODMR_DEER"]]}}
				]];
				If[!quit&&!abort&&!skip,
					NV=#[[1]];
					time=0; 
					pol=polarization=saturation=cw=cwFrequency=
							rabiFrequency=rabi=ramseyPower=g2=ramsey="tbd";
					tasks=NV/.NVtasks;
					If[!abort&&!skip&&TaskNecessary["g2",tasks]=!=False,
						TimeHarpStopMeasurement[];
						TimeHarpClearHistogramMemory[0]];
					previousData=Function[key,key/.#/.key->Null]&@
						If[FileExistsQ[#]&&tasks=!=All,
							Join[{"id"->#[[1]],"time"->#[[2]],"map"->#[[3]],"image"->#[[4]]},
								#[[5]]]&@Quiet@Get[#],
							{"id"->NV,"time"->0,"map"->map}]&@fileName[];
					If[!abort&&!skip,
						map=ChangeCurrentNVbyTag[map,NV];
						adjustMap[minCountsToStop];
						imageAfterSelection=image=makeImage[];
						If[!skip,adjustMap[minCountsToStop]]];
					If[!abort&&!skip&&TaskNecessary["g2",tasks]=!=False,
						TimeHarpStartMeasurement[]];
					If[!abort&&!skip&&TaskNecessary["polarization",tasks]=!=False,
						pol=PolarizationRotatorGetAngle[];
						{pol,minCountsToStop,polarization}=
							Module[{previousResult=previousData["polarization"]},
								If[TaskNecessary["polarization",tasks]==="restart"||
										previousResult===Null,
									Block[{x,\[Phi]},
										{\[Phi]/.#1[[2]],#1[[1]],#2}&@@{
											Maximize[{#[\[Phi]],0<=\[Phi]<=2*\[Pi]},\[Phi]],
											ExtractRelevantParametersFromFit[#]}&@
										LinearModelFit[
											Select[#,0<=#[[1]]<=2*\[Pi]&],
											{Cos[x/2],Sin[x/2],Cos[x],Sin[x],Cos[2*x],Sin[2*x]},x]]&@
									MeasurePolarization[RestoreAngle->False],
									Module[{fit=#[[1]],\[Phi]max=\[Pi]/180*#[[2]]},
										{\[Phi]max,Cases[fit,Line[l_List]:>l,\[Infinity]][[1]] // 
											SortBy[#,Abs[#[[1]]-\[Phi]max]&][[1,2]]&,
											fit}]&@previousResult]];
						PolarizationRotatorSetAngle[pol/2,Asynchronous->False];
						minCountsToStop=minCountsDeterminationFunction[minCountsToStop];
						If[TaskNecessary["polarization",tasks]==="restart"||
								previousResult===Null,
							image=imageAfterPolarization=makeImage[map];
							time=SessionTime[]-startTime;
							updateG2[]]];
					If[!abort&&!skip&&TaskNecessary["saturation",tasks]=!=False,
							Module[{previousResult=previousData["saturation"]},
								If[TaskNecessary["saturation",tasks]==="restart"||
										previousResult===Null,
									saturation=Block[{b,c,x0,x},ExtractRelevantParametersFromFit@
										NonlinearModelFit[#,b*x+(c*x)/(x+x0),
											{{b,10*^3/250*^-6},{c,250*^3},{x0,100*^-6}},x]]&@
										MeasureSaturation[Sequence@@("saturation"/.measurementOptions),
											LaserPowerMeterFactor->laserPowerMeterFactor];
									image=imageAfterSaturation=makeImage[map];
									time=SessionTime[]-startTime;
									updateG2[];
									saveData[],
									saturation=previousResult[[1]]]]];
					If[!abort&&!skip,
						Module[{timeBetweenAutoTracking="ODMR_cw"/.timesBetweenAutoTracking,
								snapshotIntervall="ODMR_cw"/.snapshotIntervalls,
								snapshotFileDirectory=filePrefix<>NV<>"_ODMR_cw",
								frequencies="ODMR_cw"/.frequencies,
								power="ODMR_cw"/.microwavePowers,
								previousResult=previousData["ODMR_cw"],
								maxScans="ODMR_cw"/.maxScans},
							If[0<snapshotIntervall<\[Infinity],
								Quiet[CreateDirectory[snapshotFileDirectory]]];
							cwFit=cw=If[TaskNecessary["ODMR_cw",tasks]=!=False&&
									(previousResult===Null||symbolQ[previousResult[[1]]]||
										previousResult[[1,5]]<maxScans||
										TaskNecessary["ODMR_cw",tasks]==="restart"),
								cwData=If[Head[#]=!=$Failed,#,skip=True;List@@#]&@
									ODMRcw[map,frequencies,
										powerTranslationFunction[power,frequencies],
										Sequence@@("ODMR_cw"/.measurementOptions),
										TrackerEnabled->True,
										TrackerMinCountsToStop->minCountsToStop,
										TrackerMinCountsToTrack->minCountsToTrack,
										TrackerMinCountsToFail->minCountsToFail,
										TrackerMaxCountsVariation->maxCountsVariation,
										FixedAxes->fixedAxes,
										Autorun->True,
										TimeBetweenAutoTracking->timeBetweenAutoTracking,
										MaxScans->maxScans,
										SnapshotIntervall->snapshotIntervall,
										SnapshotFilePrefix->FileNameJoin[{snapshotFileDirectory,
											"snapshot"}],
										PreviousData->If[TaskNecessary["ODMR_cw",tasks]=!="restart",
											If[0<snapshotIntervall<\[Infinity],
												restoreLatestSnapshot[snapshotFileDirectory],
												If[previousResult=!=Null,previousResult[[1]]]]]];
								If[cwData[[5]]>0,
									ODMRautoLineFit[
										ListLinePlot[#,PlotRange->All]&@
											Transpose[Function[{x,y},{Mean[x],Total[y]}]@@
												Transpose[Cases[#,Line[l_List]:>l,\[Infinity]][[1]]&/@#,
													{2,3,1}]]&@cwData[[1]],MaxPeaks->1,
										ExpectedFWHM->expectedFWHM]],previousResult[[2]]];
							cwFrequency=cwFit[[1,2,1,1,3,2]];
							fwhm=cwFit[[1,2,1,1,4,2]];
							cwContrast=-cwFit[[1,2,1,1,5,2]];
							If[TaskNecessary["ODMR_cw",tasks]=!=False&&
									(previousResult===Null||symbolQ[previousResult[[1]]]||
										previousResult[[1,5]]<maxScans||
										TaskNecessary["ODMR_cw",tasks]==="restart"),
								image=imageAfterCW=makeImage[map];
								time=SessionTime[]-startTime;
								updateG2[];
								saveData[]]]];
					If[!abort&&!skip&&cwContrast>=minCWcontrast&&minFWHM<=fwhm<=maxFWHM,
						If[!abort&&!skip,
							Module[{
									timeBetweenAutoTracking="ODMR_Rabi"/.timesBetweenAutoTracking,
									snapshotIntervall="ODMR_Rabi"/.snapshotIntervalls,
									snapshotFileDirectory=filePrefix<>NV<>"_ODMR_Rabi",
									frequency=If[#===Automatic,cwFrequency,#]&[
										"ODMR_Rabi"/.frequencies],
									power="ODMR_Rabi"/.microwavePowers,
									curve="ODMR_Rabi"/.rabiPlayerCurves,
									previousResult=previousData["ODMR_Rabi"],
									maxScans="ODMR_Rabi"/.maxScans},
								If[0<snapshotIntervall<\[Infinity],
									Quiet[CreateDirectory[snapshotFileDirectory]]];
								rabiFit=rabi=
									If[TaskNecessary["ODMR_Rabi",tasks]=!=False&&
											(previousResult===Null||symbolQ[previousResult[[1]]]||
												previousResult[[1,7]]<maxScans||
												TaskNecessary["ODMR_Rabi",tasks]==="restart"),
										rabiData=If[Head[#]=!=$Failed,#,skip=True;List@@#]&@
											ODMRrabi[map,frequency,
												powerTranslationFunction[power,frequency],
												curve,
												Sequence@@("ODMR_Rabi"/.measurementOptions),
												Sequence@@rabiPlayerOptions,
												NormalizeCounts->True,
												Autorun->True,
												TrackerEnabled->True,
												TimeBetweenAutoTracking->timeBetweenAutoTracking,
												TrackerMinCountsToStop->minCountsToStop,
												TrackerMinCountsToTrack->minCountsToTrack,
												TrackerMinCountsToFail->minCountsToFail,
												TrackerMaxCountsVariation->maxCountsVariation,
												FixedAxes->fixedAxes,
												MaxScans->maxScans,
												SnapshotIntervall->snapshotIntervall,
												SnapshotFilePrefix->FileNameJoin[{snapshotFileDirectory,
													"snapshot"}],
												PreviousData->If[
													TaskNecessary["ODMR_Rabi",tasks]=!="restart",
													If[0<snapshotIntervall<\[Infinity],
														restoreLatestSnapshot[snapshotFileDirectory],
														If[previousResult=!=Null,previousResult[[1]]]]]];
										If[rabiData[[7]]>0,fitDampedOscillation[rabiData]],
										previousResult[[2]]];
						rabiFrequency=If[rabiFit=!=Null,rabiFit[[2,1,1,5,2]],0];
						If[TaskNecessary["ODMR_Rabi",tasks]=!=False&&
								(previousResult===Null||symbolQ[previousResult[[1]]]||
									previousResult[[1,7]]<maxScans||
									TaskNecessary["ODMR_Rabi",tasks]==="restart"),
							image=imageAfterRabi=makeImage[map];
							time=SessionTime[]-startTime;
							updateG2[];
							saveData[]]]];
					If[!abort&&!skip&&rabiFrequency>0,
						If[!abort&&!skip&&TaskNecessary["ODMR_Ramsey",tasks]=!=False,
							Module[{
									timeBetweenAutoTracking="ODMR_Ramsey"/.timesBetweenAutoTracking,
									snapshotIntervall="ODMR_Ramsey"/.snapshotIntervalls,
									snapshotFileDirectory=filePrefix<>NV<>"_ODMR_Ramsey",
									frequency=If[#===Automatic,cwFrequency,#]&[
										"ODMR_Ramsey"/.frequencies],
									rabiPower="ODMR_Rabi"/.microwavePowers,
									power="ODMR_Ramsey"/.microwavePowers,
									curve="ODMR_Ramsey"/.rabiPlayerCurves,
									targetRabiFrequency="ODMR_Ramsey"/.targetRabiFrequencies,
									previousResult=previousData["ODMR_Ramsey"],
									maxScans="ODMR_Ramsey"/.maxScans},
								If[0<snapshotIntervall<\[Infinity],
									Quiet[CreateDirectory[snapshotFileDirectory]]];
								If[power===Automatic,power=
									rabiPower+20*Log[10,targetRabiFrequency/rabiFrequency]];
								ramseyPower=power;
								If[NumericQ[power]&&power<=maxPower&&
										(previousResult===Null||symbolQ[previousResult[[1]]]||
											previousResult[[1,7]]<maxScans||
											TaskNecessary["ODMR_Ramsey",tasks]==="restart"),
									ramseyData=If[Head[#]=!=$Failed,#,skip=True;List@@#]&@
										ODMRrabi[map,frequency,
											powerTranslationFunction[power,frequency],
											curve,
											Sequence@@("ODMR_Ramsey"/.measurementOptions),
											Sequence@@rabiPlayerOptions,
											NormalizeCounts->True,
											Autorun->True,
											TrackerEnabled->True,
											TimeBetweenAutoTracking->timeBetweenAutoTracking,
											TrackerMinCountsToStop->minCountsToStop,
											TrackerMinCountsToTrack->minCountsToTrack,
											TrackerMinCountsToFail->minCountsToFail,
											TrackerMaxCountsVariation->maxCountsVariation,
											FixedAxes->fixedAxes,
											MaxScans->maxScans,
											SnapshotIntervall->snapshotIntervall,
											SnapshotFilePrefix->FileNameJoin[{snapshotFileDirectory,
												"snapshot"}],
											PreviousData->If[
												TaskNecessary["ODMR_Ramsey",tasks]=!="restart",
												If[0<snapshotIntervall<\[Infinity],
													restoreLatestSnapshot[snapshotFileDirectory],
													If[previousResult=!=Null,previousResult[[1]]]]]];
									ramseyFit=ramsey=If[ramseyData[[7]]>0,
										fitDampedOscillation[ramseyData]];
									image=imageAfterRamsey=makeImage[map];
									time=SessionTime[]-startTime;
									updateG2[];
									saveData[]]]];
						If[!abort&&!skip&&TaskNecessary["ODMR_Hahn",tasks]=!=False,
							Module[{
									timeBetweenAutoTracking="ODMR_Hahn"/.timesBetweenAutoTracking,
									snapshotIntervall="ODMR_Hahn"/.snapshotIntervalls,
									snapshotFileDirectory=filePrefix<>NV<>"_ODMR_Hahn",
									frequency=If[#===Automatic,cwFrequency,#]&[
										"ODMR_Hahn"/.frequencies],
									rabiPower="ODMR_Rabi"/.microwavePowers,
									power="ODMR_Hahn"/.microwavePowers,
									curve="ODMR_Hahn"/.rabiPlayerCurves,
									targetRabiFrequency="ODMR_Hahn"/.targetRabiFrequencies,
									previousResult=previousData["ODMR_Hahn"],
									maxScans="ODMR_Hahn"/.maxScans},
								If[0<snapshotIntervall<\[Infinity],
									Quiet[CreateDirectory[snapshotFileDirectory]]];
								If[power===Automatic,power=
									rabiPower+20*Log[10,targetRabiFrequency/rabiFrequency]];
								hahnPower=power;
								If[NumericQ[power]&&power<=maxPower&&
										(previousResult===Null||symbolQ[previousResult[[1]]]||
											previousResult[[1,7]]<maxScans||
											TaskNecessary["ODMR_Hahn",tasks]==="restart"),
									hahnData=If[Head[#]=!=$Failed,#,skip=True;List@@#]&@
										ODMRrabi[map,frequency,
											powerTranslationFunction[power,frequency],
											curve,
											Sequence@@("ODMR_Hahn"/.measurementOptions),
											Sequence@@rabiPlayerOptions,
											NormalizeCounts->True,
											Autorun->True,
											TrackerEnabled->True,
											TimeBetweenAutoTracking->timeBetweenAutoTracking,
											TrackerMinCountsToStop->minCountsToStop,
											TrackerMinCountsToTrack->minCountsToTrack,
											TrackerMinCountsToFail->minCountsToFail,
											TrackerMaxCountsVariation->maxCountsVariation,
											FixedAxes->fixedAxes,
											MaxScans->maxScans,
											SnapshotIntervall->snapshotIntervall,
											SnapshotFilePrefix->FileNameJoin[{snapshotFileDirectory,
												"snapshot"}],
											PreviousData->If[
												TaskNecessary["ODMR_Hahn",tasks]=!="restart",
												If[0<snapshotIntervall<\[Infinity],
													restoreLatestSnapshot[snapshotFileDirectory],
													If[previousResult=!=Null,previousResult[[1]]]]]];
									hahnFit=If[hahnData[[7]]>0,fitDampedOscillation[hahnData]]];
									image=imageAfterHahn=makeImage[map];
									time=SessionTime[]-startTime;
									updateG2[];
									saveData[]]];
						If[!abort&&!skip&&TaskNecessary["ODMR_pulsed",tasks]=!=False,
							Module[{
									timeBetweenAutoTracking="ODMR_pulsed"/.timesBetweenAutoTracking,
									snapshotIntervall="ODMR_pulsed"/.snapshotIntervalls,
									snapshotFileDirectory=filePrefix<>NV<>"_ODMR_pulsed",
									pulsedFrequencies=Switch[#,_Function,#[cwFrequency],_,#]&[
										"ODMR_pulsed"/.frequencies],
									rabiPower="ODMR_Rabi"/.microwavePowers,
									power="ODMR_pulsed"/.microwavePowers,
									curve="ODMR_pulsed"/.rabiPlayerCurves,
									targetRabiFrequency="ODMR_pulsed"/.targetRabiFrequencies,
									previousResult=previousData["ODMR_pulsed"],
									maxScans="ODMR_pulsed"/.maxScans},
								If[0<snapshotIntervall<\[Infinity],
									Quiet[CreateDirectory[snapshotFileDirectory]]];
								If[power===Automatic,power=
									rabiPower+20*Log[10,targetRabiFrequency/rabiFrequency]];
								pulsedPower=power;
								If[NumericQ[power]&&power<=maxPower&&
										(previousResult===Null||symbolQ[previousResult[[1]]]||
											previousResult[[1,6]]<maxScans||
											TaskNecessary["ODMR_pulsed",tasks]==="restart"),
									pulsedData=If[Head[#]=!=$Failed,#,skip=True;List@@#]&@
										ODMRpulsed[map,pulsedFrequencies,
											powerTranslationFunction[power,pulsedFrequencies],
											targetRabiFrequency,
											Sequence@@("ODMR_pulsed"/.measurementOptions),
											Sequence@@pulsedSpectrumOptions,
											NormalizeCounts->True,
											Autorun->True,
											TrackerEnabled->True,
											TimeBetweenAutoTracking->timeBetweenAutoTracking,
											TrackerMinCountsToStop->minCountsToStop,
											TrackerMinCountsToTrack->minCountsToTrack,
											TrackerMinCountsToFail->minCountsToFail,
											TrackerMaxCountsVariation->maxCountsVariation,
											FixedAxes->fixedAxes,
											MaxScans->maxScans,
											SnapshotIntervall->snapshotIntervall,
											SnapshotFilePrefix->FileNameJoin[{snapshotFileDirectory,
												"snapshot"}],
											PreviousData->If[
												TaskNecessary["ODMR_pulsed",tasks]=!="restart",
												If[0<snapshotIntervall<\[Infinity],
													restoreLatestSnapshot[snapshotFileDirectory],
													If[previousResult=!=Null,previousResult[[1]]]]]];
									image=imageAfterPulsed=makeImage[map];
									time=SessionTime[]-startTime;
									updateG2[];
									saveData[]]]];
						If[!abort&&!skip&&TaskNecessary["ODMR_DEER",tasks]=!=False,
							Module[{
									timeBetweenAutoTracking="ODMR_DEER"/.timesBetweenAutoTracking,
									snapshotIntervall="ODMR_DEER"/.snapshotIntervalls,
									snapshotFileDirectory=filePrefix<>NV<>"_ODMR_DEER",
									pulsedFrequencies=Switch[#,_Function,#[cwFrequency],_,#]&[
										"ODMR_DEER"/.frequencies],
									rabiPower="ODMR_Rabi"/.microwavePowers,
									power="ODMR_DEER"/.microwavePowers,
									curve="ODMR_DEER"/.rabiPlayerCurves,
									targetRabiFrequency="ODMR_DEER"/.targetRabiFrequencies,
									previousResult=previousData["ODMR_DEER"],
									maxScans="ODMR_DEER"/.maxScans,
									s=Function[ToString[#,CForm]],
									fPulse=cwFrequency,pPulse,pSweep},
								If[0<snapshotIntervall<\[Infinity],
									Quiet[CreateDirectory[snapshotFileDirectory]]];
								{pPulse,pSweep}=If[#[[1]]===Automatic,
										rabiPower+20*Log[10,#[[2]]/rabiFrequency],#[[1]]]&/@
									Transpose[Switch[#,{_,_},#,_,{#,#}]&/@
										{power,targetRabiFrequency}];
								deerPower={pPulse,pSweep};
								If[And@@(NumericQ[#]&&#<=maxPower&/@{pPulse,pSweep})&&
										(previousResult===Null||symbolQ[previousResult[[1]]]||
											previousResult[[1,6]]<maxScans||
											TaskNecessary["ODMR_DEER",tasks]==="restart"),
									SCPIcmd[secondaryMicrowave,":FREQ:MODE CW"];
									SCPIcmd[secondaryMicrowave,":POWER:MODE FIX"];
									SCPIcmd[secondaryMicrowave,":OUTP:STATE 0"];
									SCPIcmd[secondaryMicrowave,":FREQ "<>s[fPulse]];
									SCPIcmd[secondaryMicrowave,":POWER "<>
										s[powerTranslationFunction[pPulse,fPulse]]]; 
    							SCPIcmd[secondaryMicrowave,":PULM:STATE OFF"];
									SCPIcmd[secondaryMicrowave,":DM:IQ:STATE OFF"];
									SCPIcmd[secondaryMicrowave,":OUTP:STATE 1"];
									deerData=If[Head[#]=!=$Failed,#,skip=True;List@@#]&@
										ODMRpulsed[map,pulsedFrequencies,
											powerTranslationFunction[pSweep,pulsedFrequencies],
											targetRabiFrequency[[2]],
											MicrowaveSequenceForPulsing->curve,
											Sequence@@FilterRules["ODMR_DEER"/.measurementOptions,
												Options[ODMRpulsed]],
											Sequence@@pulsedSpectrumOptions,
											NormalizeCounts->True,
											Autorun->True,
											TrackerEnabled->True,
											TimeBetweenAutoTracking->timeBetweenAutoTracking,
											TrackerMinCountsToStop->minCountsToStop,
											TrackerMinCountsToTrack->minCountsToTrack,
											TrackerMinCountsToFail->minCountsToFail,
											TrackerMaxCountsVariation->maxCountsVariation,
											FixedAxes->fixedAxes,
											MaxScans->maxScans,
											SnapshotIntervall->snapshotIntervall,
											SnapshotFilePrefix->FileNameJoin[{snapshotFileDirectory,
												"snapshot"}],
											PreviousData->If[
												TaskNecessary["ODMR_DEER",tasks]=!="restart",
												If[0<snapshotIntervall<\[Infinity],
													restoreLatestSnapshot[snapshotFileDirectory],
													If[previousResult=!=Null,previousResult[[1]]]]]];
									SCPIcmd[secondaryMicrowave,":OUTP:STATE 0"];
									image=imageAfterDEER=makeImage[map];
									time=SessionTime[]-startTime;
									updateG2[];
									saveData[]]]]]];
					If[TaskNecessary["g2",tasks]=!=False,TimeHarpStopMeasurement[]];
					time=SessionTime[]-startTime;
					updateG2[];
					saveData[]]
					]&/@Select[map[[1]],NVselector[#[[1]]]&],
			{Button[If[abort,"doNotAbort","abort"],abort=!abort],
				Button[If[quit,"doNotQuit","quit"],quit=!quit],
				Button[If[skip,"doNotSkip","skip"],skip=!skip],
				NV,time,g2,
				(*Refresh[{TimeHarpGetElapsedMeasurementTime[],
						ListLinePlot[
							Transpose[{resolution*(Range[Length[#]]-1),#}]&@
						TimeHarpGetHistogramBlock[0],PlotRange\[Rule]All]},
					UpdateInterval\[Rule]10,TrackedSymbols\[Rule]{}],*)
				180./\[Pi]*pol,PlotAndAnnotateConfocalImage[image,map,
					MaxCounts->imageMaxCounts],
				lastCorrelationImage,polarization,saturation,cw,
				rabi,ramseyPower,ramsey,hahnPower,hahn,pulsedPower,pulsed,deerPower}]]];
